#!/home/ywan/soft/anaconda3/bin/python
from sklearn import linear_model,svm,tree,preprocessing
from sklearn.model_selection import train_test_split, ShuffleSplit, learning_curve
from sklearn.ensemble import RandomForestClassifier, RandomForestRegressor
import matplotlib.pyplot as plt
import numpy as np
import plot, INPUT, correlation

feature_index = 2
feature = INPUT.feature(feature_index)
names = INPUT.feature_name(feature_index)
names = np.arange(0,9,1)
name = 'all.dat'
def transform(fileName):    
    import random
    fr = open(fileName)
    line = fr.readlines()
    num = []
    for i in range(len(line)):
        num.append(i)
#    random.shuffle(num)
    fn = open('dig_%s' % fileName, 'w')
    for i in num:
        numofline = len(line[i].split())
        name = line[i].split()[0].split("-")
        fn.write( feature[name[0]] + ' ' + feature[name[1]] + ' ' +  '%2s' % name[2][1:]  +  '  ' + '%5s' % feature[name[3][:-2]] + '   ' + '%5s' % feature[name[3][-2:]])
        for x in range(1,numofline):
            fn.write('  ' + line[i].split()[x] )
        fn.write('\n')
    fn.close()
transform(name)
transform('verification.dat')

def loadDataSet(fileName,target,num):
    numFeat = len(open(fileName).readline().split()) 
    fr = open(fileName)
    dataMat = []
    labelMat = []
    for line in fr.readlines():
        lineArr = []
        curLine = line.split()
        for i in range(num):
            lineArr.append(float(curLine[i]))
        dataMat.append(lineArr)
        labelMat.append(float(curLine[target]))
    return dataMat,labelMat

def Removing_features_with_low_variance():
    X, y = loadDataSet('dig_%s' % name,-2,15)
    min_max_scaler = preprocessing.MinMaxScaler()
    X = min_max_scaler.fit_transform(X)
    #X = preprocessing.scale(X)
    print (np.shape(X))
    from sklearn.feature_selection import VarianceThreshold
    sel = VarianceThreshold(threshold=(.8 * (1 - .8)))
    sel.fit_transform(X)
    print (np.shape(X))

def Pearson_Correlation():
    from scipy.stats import pearsonr
    X, HOMO = loadDataSet('dig_%s' % name,-3,len(names))
    X, gap = loadDataSet('dig_%s' % name,-2,len(names))
    X, LUMO = loadDataSet('dig_%s' % name,-1,len(names))
    X = np.array(X)
    min_max_scaler = preprocessing.MinMaxScaler()
    X = min_max_scaler.fit_transform(X)
    #X = preprocessing.scale(X)
    pearson_co = []
    for i in range(len(names)):
        co = []
        for a in range(len(names)):
            a,b = pearsonr(X[:,i],X[:,a])
            a = round(a, 3)
            co.append(a)
        pearson_co.append(co)
#    print (pearson_co[0])
    co_gap = []
    co_LUMO = []
    co_HOMO = []
    for i in range(len(names)):
        a1,b1 = pearsonr(X[:,i],HOMO)
        a2,b2 = pearsonr(X[:,i],gap)
        a3,b3 = pearsonr(X[:,i],LUMO)
        co_HOMO.append(a1)
        co_gap.append(a2)
        co_LUMO.append(a3)
    return pearson_co, co_HOMO, co_gap, co_LUMO

def mean_decrease_impurity(num):
    from sklearn.ensemble import RandomForestRegressor
    X, y = loadDataSet('dig_%s' % name,num,len(names))
    min_max_scaler = preprocessing.MinMaxScaler()
    X = min_max_scaler.fit_transform(X)
#    X = preprocessing.scale(X)
    rf = RandomForestRegressor()
    rf.fit(X, y)
    #print (sorted(zip(map(lambda x: round(x, 4), rf.feature_importances_), names), reverse=True))
    return rf.feature_importances_ 

def lasso():
    X, y = loadDataSet('dig_%s' % name,-1,15)
    X = preprocessing.scale(X)
    reg = linear_model.Lasso(alpha=0.01)
    reg.fit(X,y)
    print (reg.coef_)

def learningcurve(regr,target,name):
    X, y = loadDataSet('dig_%s.dat' % name,target,9)
    X = preprocessing.scale(X)
    cv = ShuffleSplit(n_splits=10, test_size=0.2, random_state=0)
    title = r"LearningCurves:%s" % 'SVR'
    plot.plot_learning_curve(regr, title, X, y, ylim=(0.9, 1.01), cv=cv, n_jobs=4)
#    plt.savefig('learning_curves_%s' % dic[target],bbox_inches='tight')
    plt.show()
dic = {-2:'HOMO',-1:'gap'}
regr_svr_gap = svm.SVR(gamma=0.10,C=10)
regr_svr_HOMO = svm.SVR(gamma=0.05,C=10)
regr_svr_LUMO = svm.SVR(gamma=0.06,C=10)

def regression(regr,target,num,fig_name):
    from sklearn.metrics import mean_absolute_percentage_error,mean_squared_error,r2_score
    from sklearn.model_selection import train_test_split,cross_val_score, learning_curve
    X, y = loadDataSet('dig_all.dat',target,num)
    verific_X, verific_y = loadDataSet('dig_verification.dat',target,num)
    numverification = len(verific_y)
    X = np.array(X)
    verific_X = np.array(verific_X)
    X = np.vstack((X,verific_X))
    X = np.delete(X,6,axis=1)
    if (target == -4):
        X = np.delete(X,1,axis=1)
    else:
        pass
    X = preprocessing.scale(X)
    #min_max_scaler = preprocessing.MinMaxScaler()
    #X = min_max_scaler.fit_transform(X)
    train_X,test_X,train_y,test_y = train_test_split(X[:-numverification],y,test_size=250,random_state=1)
    verific_X = X[-numverification:]
    regr.fit(train_X,train_y)
    pred_y_train = regr.predict(train_X)
    pred_y_test = regr.predict(test_X)
    regr.fit(X[:-numverification:],y)
    pred_y_verific = regr.predict(verific_X)
    error = []
    #for i in range(numverification):
    #    err = pred_y_verific[i] - verific_y[i]
    for i in range(250):
        err = pred_y_test[i] - test_y[i]
        #print ('%.3f' % err)
        error.append(err)
    #print (max(error))
#    print (error)
    #plot.drawHist(error,5,fig_name)
    MAPE_train = mean_absolute_percentage_error(train_y, pred_y_train)
    MAPE_test = mean_absolute_percentage_error(test_y,pred_y_test)
    MAPE_verifi = mean_absolute_percentage_error(verific_y,pred_y_verific)
    RMSE_train = mean_squared_error(train_y, pred_y_train,squared=False)
    RMSE_test = mean_squared_error(test_y, pred_y_test,squared=False)
    RMSE_verifi = mean_squared_error(verific_y,pred_y_verific,squared=False)
    R2_train = r2_score(train_y, pred_y_train)
    R2_test = r2_score(test_y, pred_y_test)
    R2_verifi = r2_score(verific_y,pred_y_verific)
    print (round(MAPE_train,4),'\t',round(MAPE_test,4),'\t',round(MAPE_verifi,4),'\t',round(RMSE_train,4),'\t',round(RMSE_test,4),'\t',round(RMSE_verifi,4),'\t',round(R2_train,4),'\t',round(R2_test,4),'\t',round(R2_verifi,4))
#    plot.comparison(train_y,pred_y_train,test_y,pred_y_test,verific_y,pred_y_verific,fig_name)
regression(regr_svr_HOMO,-3,9,'SVR_HOMO')
regression(regr_svr_LUMO,-1,9,'SVR_LUMO')

