#!/home/ywan/soft/anaconda3/bin/python
from sklearn import linear_model,svm,tree,preprocessing
from sklearn.model_selection import KFold
from sklearn.ensemble import RandomForestClassifier, RandomForestRegressor
import matplotlib.pyplot as plt
import numpy as np
import plot, INPUT, correlation

feature_index = 2
feature = INPUT.feature(feature_index)
names = INPUT.feature_name(feature_index)

name = 'all.dat'
#name = 'application.dat'
def transform(fileName):    
    import random
    fr = open(fileName)
    line = fr.readlines()
    num = []
    for i in range(len(line)):
        num.append(i)
    random.shuffle(num)
    fn = open('dig_%s' % fileName, 'w')
    for i in num:
        numofline = len(line[i].split())
        name = line[i].split()[0].split("-")
        fn.write( feature[name[0]] + ' ' + feature[name[1]] + ' ' +  '%2s' % name[2][1:]  +  '  ' + '%5s' % feature[name[3][:-2]] + '   ' + '%5s' % feature[name[3][-2:]])
        for x in range(1,numofline):
            fn.write('  ' + line[i].split()[x] )
        fn.write('\n')
    fn.close()
transform(name)

def loadDataSet(fileName,target,num):
    numFeat = len(open(fileName).readline().split()) 
    fr = open(fileName)
    dataMat = []
    labelMat = []
    for line in fr.readlines():
        lineArr = []
        curLine = line.split()
        for i in range(num):
            lineArr.append(float(curLine[i]))
        dataMat.append(lineArr)
        labelMat.append(float(curLine[target]))
    return dataMat,labelMat

dic = {-2:'IP',-1:'gap'}
regr_svr_gap = svm.SVR(gamma=0.10,C=10)
regr_svr_IP = svm.SVR(gamma=0.05,C=10)
regr_svr_EA = svm.SVR(gamma=0.06,C=10)
from sklearn.kernel_ridge import KernelRidge
from sklearn.gaussian_process import GaussianProcessRegressor
regr_krr_gap = KernelRidge(kernel="rbf",gamma=0.10)
regr_krr_IP = KernelRidge(kernel="rbf",gamma=0.03)
regr_krr_EA = KernelRidge(kernel="rbf",gamma=0.03)
regr_gpr_gap = GaussianProcessRegressor()
regr_gpr_IP = GaussianProcessRegressor()

def varname(p):
    import inspect, re
    for line in inspect.getframeinfo(inspect.currentframe().f_back)[3]:
        m = re.search(r'\bvarname\s*\(\s*([A-Za-z_][A-Za-z0-9_]*)\s*\)', line)
        if m:
            return m.group(1)

def regression(regr,target,num,name):
    from sklearn.metrics import mean_absolute_percentage_error,mean_squared_error,r2_score
    X, y = loadDataSet('dig_all.dat',target,num)
#    min_max_scaler = preprocessing.MinMaxScaler()
#    X = min_max_scaler.fit_transform(X)
    X = preprocessing.scale(X)
    X = np.delete(X,6,axis=1)
    if (target == -4):
        X = np.delete(X,1,axis=1)
    else:
        pass
    kf=KFold(n_splits=10,shuffle=False)
    kf.split(X)
    f = open('%s-score.dat' % name, 'w')
    for train_index,test_index in kf.split(X,y):
        train_X = X[train_index]
        test_X = X[test_index]
        train_y = np.array(y)[train_index]
        test_y= np.array(y)[test_index]
        regr.fit(train_X,train_y)
        pred_y_train = regr.predict(train_X)
        pred_y_test = regr.predict(test_X)
        MAPE_train = mean_absolute_percentage_error(train_y, pred_y_train)
        MAPE_test = mean_absolute_percentage_error(test_y, pred_y_test)
        RMSE_train = mean_squared_error(train_y, pred_y_train,squared=False)
        RMSE_test = mean_squared_error(test_y, pred_y_test,squared=False)
        R2_train = r2_score(train_y, pred_y_train)
        R2_test = r2_score(test_y, pred_y_test)
        f.write('%.3f' % MAPE_train + '\t' + '%.3f' % MAPE_test + '\t' + '%.3f' % RMSE_train + '\t' + '%.3f' % RMSE_test + '\t' + '%.3f' % R2_train + '\t' + '%.3f' % R2_test + '\n')
    f.close()
regression(regr_svr_IP,-3,9,'svr-IP')
#regression(regr_krr_IP,-3,8,'krr-IP')
regression(regr_svr_EA,-1,9,'svr-EA')
#regression(regr_krr_EA,-1,8,'krr-EA')
#plot.score('gap')
#plot.score('IP')
